Debian Bug report logs - #657560
apt-get errors out when unable to uncompress a Translation-fr.bz2 file due to missing bzip2

version graph

Package: apt; Maintainer for apt is APT Development Team <deity@lists.debian.org>; Source for apt is src:apt.

Reported by: Michael Prokop <mika@debian.org>

Date: Fri, 27 Jan 2012 00:12:01 UTC

Severity: serious

Merged with 657563, 659049

Found in version apt/0.8.15.9

Fixed in versions apt/0.8.16~exp13, apt/0.9.0

Done: Michael Vogt <mvo@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Fri, 27 Jan 2012 00:12:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
New Bug report received and forwarded. Copy sent to APT Development Team <deity@lists.debian.org>. (Fri, 27 Jan 2012 00:12:04 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: apt: ...i18n_Translation-en Encountered a section with no Package: header
Date: Fri, 27 Jan 2012 01:07:58 +0100
Package: apt
Version: 0.8.15.9
Severity: important


Fresh wheezy chroot as of today:

,---- [ cmdline ]
| # debootstrap wheezy /tmp/basefile http://cdn.debian.net/debian
| # chroot /tmp/basefile /bin/bash
| # dpkg --list | grep zip
| ii  gzip                            1.4-2                   GNU compression utilities
| # dpkg --list | grep libbz2
| ii  libbz2-1.0                      1.0.6-1                 high-quality block-sorting file compressor library - runtime
| # sed -i 's/wheezy/sid/' /etc/apt/sources.list
| # apt-get update
| Get:1 http://cdn.debian.net sid InRelease [190 kB]
| Get:2 http://cdn.debian.net sid/main TranslationIndex [2154 B]
| Get:3 http://cdn.debian.net sid/main amd64 Packages [7388 kB]
| Get:4 http://cdn.debian.net sid/main Translation-en [3860 kB]
| Fetched 11.4 MB in 4s (2537 kB/s)
| W: Failed to fetch copy:/var/lib/apt/lists/partial/cdn.debian.net_debian_dists_sid_main_i18n_Translation-en  Encountered a section with no Package: header
|
| E: Some index files failed to download. They have been ignored, or old ones used instead.
`----

Looking at strace output apt-get is trying to retrieve
Translation-en.xz, then Translation-en.gz and finally
Translation-en. None of them exist on
$MIRROR/debian/dists/sid/main/i18n/ but only *.bz2 files.

FTR: It's not related to usage of cdn.debian.net nor a mirror
specific issue and I can easily reproduce it.

regards,
-mika-




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Fri, 27 Jan 2012 00:33:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Fri, 27 Jan 2012 00:33:05 GMT) Full text and rfc822 format available.

Message #10 received at 657560@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: 657560@bugs.debian.org
Subject: Re: Bug#657560: apt: ...i18n_Translation-en Encountered a section with no Package: header)
Date: Fri, 27 Jan 2012 01:29:43 +0100
[Message part 1 (text/plain, inline)]
* Debian Bug Tracking System [Fri Jan 27, 2012 at 12:12:04AM +0000]:

[...]

Followup: also see #657563 for same issue with aptitude.
Problem seems to be solved as soon as bzip2 is installed.

regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Fri, 27 Jan 2012 21:03:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Michael Prokop <mika@debian.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Fri, 27 Jan 2012 21:03:07 GMT) Full text and rfc822 format available.

Message #15 received at 657560@bugs.debian.org (full text, mbox):

From: Michael Prokop <mika@debian.org>
To: 657563@bugs.debian.org
Cc: 657029@bugs.debian.org, 657560@bugs.debian.org
Subject: bzip2-only Translation files - apt/aptitude failing
Date: Fri, 27 Jan 2012 22:01:09 +0100
[Message part 1 (text/plain, inline)]
All of:

#657029 - mirrors: apt-get update does not understand content negotiation
#657560 - apt: ...i18n_Translation-en Encountered a section with no Package: header
#657563 - aptitude: Fails on bzip2-only Translation files

are about the same issue, leaving the according merge and further
actions to the maintainers though (especially as apt can't continue
in the situation, while aptitude can but doesn't provide any details
about the error, see according bugreports for details).

JFYI && regards,
-mika-
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Thu, 01 Mar 2012 14:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Didier 'OdyX' Raboud" <odyx@debian.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Thu, 01 Mar 2012 14:39:03 GMT) Full text and rfc822 format available.

Message #20 received at 657560@bugs.debian.org (full text, mbox):

From: "Didier 'OdyX' Raboud" <odyx@debian.org>
To: 657560@bugs.debian.org
Cc: Michael Prokop <mika@debian.org>, debian-boot@lists.debian.org
Subject: #657560: apt: ...i18n_Translation-en Encountered a section with no Package: header
Date: Thu, 01 Mar 2012 15:35:51 +0100
[Message part 1 (text/plain, inline)]
severity 657560 serious
thanks

Le 27.01.2012 22:01, Michael Prokop a écrit :
> All of:
> 
> #657029 - mirrors: apt-get update does not understand content negotiation
> #657560 - apt: ...i18n_Translation-en Encountered a section with no Package: header
> #657563 - aptitude: Fails on bzip2-only Translation files
> 
> are about the same issue, leaving the according merge and further
> actions to the maintainers though (especially as apt can't continue
> in the situation, while aptitude can but doesn't provide any details
> about the error, see according bugreports for details).

I'm hereby rising the severity of this bug above RC level because it
makes current daily builds of the debian-installer fail due to "unknown"
errors (those are not easy to track down). When actually taking a look
at /var/log/syslog, that's where the "Encountered a section with no
Package: header" appears. This error is thrown out because apt fails to
uncompress the Translation-*.bz2 files in absence of bzip2 and then
fails to read them (eh, they are still compressed).

(Workaround for users of the debian-installer dailies is then to `chroot
/target; apt-get install bzip2` and hit "retry". )

So apt should either:

a) gracefully fallback on short translations when it fails to
uncompress/parse the Translation packages;
b) Bump its Suggests: bzip to a {Pre-}Depends on bzip2 / libbz2-1.0 (if
sufficient) to be able to actually download and decompress
Translation-*.bz2 files (which are the only Translation-* files on the
Debian mirrors network).

Cheers,

OdyX



[signature.asc (application/pgp-signature, attachment)]

Severity set to 'serious' from 'important' Request was from "Didier 'OdyX' Raboud" <odyx@debian.org> to control@bugs.debian.org. (Thu, 01 Mar 2012 14:39:05 GMT) Full text and rfc822 format available.

Changed Bug title to 'apt-get errors out when unable to uncompress a Translation-fr.bz2 file due to missing bzip2' from 'apt: ...i18n_Translation-en Encountered a section with no Package: header' Request was from "Didier Raboud" <didier@raboud.homelinux.org> to control@bugs.debian.org. (Thu, 01 Mar 2012 14:39:07 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Tue, 06 Mar 2012 10:36:28 GMT) Full text and rfc822 format available.

Acknowledgement sent to David Kalnischkies <kalnischkies+debian@gmail.com>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Tue, 06 Mar 2012 10:36:29 GMT) Full text and rfc822 format available.

Message #29 received at 657560@bugs.debian.org (full text, mbox):

From: David Kalnischkies <kalnischkies+debian@gmail.com>
To: "Didier 'OdyX' Raboud" <odyx@debian.org>, 657560@bugs.debian.org
Subject: Re: Bug#657560: #657560: apt: ...i18n_Translation-en Encountered a section with no Package: header
Date: Tue, 6 Mar 2012 11:33:58 +0100
On Thu, Mar 1, 2012 at 15:35, Didier 'OdyX' Raboud <odyx@debian.org> wrote:
> So apt should either:
>
> a) gracefully fallback on short translations when it fails to
> uncompress/parse the Translation packages;
> b) Bump its Suggests: bzip to a {Pre-}Depends on bzip2 / libbz2-1.0 (if
> sufficient) to be able to actually download and decompress
> Translation-*.bz2 files (which are the only Translation-* files on the
> Debian mirrors network).

Neither is a good solution, especially b) is a complete overreaction.

The problem is here that some (yes, neither all nor many) mirrors try content-
negotiation for the request of Translation-en even though the requesting
client (apt in this case) hasn't indicated that it would support this.

I have added (scheduled for experimental) code to send a 'Accept: text/*'
header in case the file we request in http(s) doesn't have an extension.
In my limited testing this caused the content-negotiation mirror to not
respond with the 'wrong' file and answer with a 404.
I had some reports that 406 can be seen, too, which isn't handled so far.

If this is really a fix will be seen in wider testing later.
I already dreamed about mirrors not sending Release-files because
they claim the mimetype is 'debian/rfc822'…
(beside the dream that Release.gpg is content-negotiation for Release)


Best regards

David Kalnischkies




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Tue, 06 Mar 2012 11:06:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to "Didier 'OdyX' Raboud" <odyx@debian.org>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Tue, 06 Mar 2012 11:06:28 GMT) Full text and rfc822 format available.

Message #34 received at 657560@bugs.debian.org (full text, mbox):

From: "Didier 'OdyX' Raboud" <odyx@debian.org>
To: David Kalnischkies <kalnischkies+debian@gmail.com>
Cc: 657560@bugs.debian.org
Subject: Re: Bug#657560: #657560: apt: ...i18n_Translation-en Encountered a section with no Package: header
Date: Tue, 06 Mar 2012 12:00:32 +0100
[Message part 1 (text/plain, inline)]
Le 06.03.2012 11:33, David Kalnischkies a écrit :
> On Thu, Mar 1, 2012 at 15:35, Didier 'OdyX' Raboud <odyx@debian.org> wrote:
>> So apt should either:
>>
>> a) gracefully fallback on short translations when it fails to
>> uncompress/parse the Translation packages;
>> b) Bump its Suggests: bzip to a {Pre-}Depends on bzip2 / libbz2-1.0 (if
>> sufficient) to be able to actually download and decompress
>> Translation-*.bz2 files (which are the only Translation-* files on the
>> Debian mirrors network).
> 
> Neither is a good solution, especially b) is a complete overreaction.

As long as we can agree on the issue, I don't insist on apt maintainers
using my proposed solutions, eh... What matters to me is that the d-i /
apt combo can work and it currently doesn't.

> The problem is here that some (yes, neither all nor many) mirrors try content-
> negotiation for the request of Translation-en even though the requesting
> client (apt in this case) hasn't indicated that it would support this.

I'm afraid I don't understand.

Are there mirrors that have the long descriptions available in another
format than .bz2 ? Or are you saying that some mirrors send
Translation-*.bz2 files with anything else than Content-Type:
application/x-bzip2 in their HTTP headers ?

Cheers,

OdyX

[signature.asc (application/pgp-signature, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Tue, 06 Mar 2012 11:18:15 GMT) Full text and rfc822 format available.

Acknowledgement sent to David Kalnischkies <kalnischkies+debian@gmail.com>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Tue, 06 Mar 2012 11:18:18 GMT) Full text and rfc822 format available.

Message #39 received at 657560@bugs.debian.org (full text, mbox):

From: David Kalnischkies <kalnischkies+debian@gmail.com>
To: "Didier 'OdyX' Raboud" <odyx@debian.org>
Cc: 657560@bugs.debian.org
Subject: Re: Bug#657560: #657560: apt: ...i18n_Translation-en Encountered a section with no Package: header
Date: Tue, 6 Mar 2012 12:15:38 +0100
On Tue, Mar 6, 2012 at 12:00, Didier 'OdyX' Raboud <odyx@debian.org> wrote:
> Le 06.03.2012 11:33, David Kalnischkies a écrit :
>> On Thu, Mar 1, 2012 at 15:35, Didier 'OdyX' Raboud <odyx@debian.org> wrote:
>> The problem is here that some (yes, neither all nor many) mirrors try content-
>> negotiation for the request of Translation-en even though the requesting
>> client (apt in this case) hasn't indicated that it would support this.
>
> I'm afraid I don't understand.
>
> Are there mirrors that have the long descriptions available in another
> format than .bz2 ? Or are you saying that some mirrors send
> Translation-*.bz2 files with anything else than Content-Type:
> application/x-bzip2 in their HTTP headers ?

No, i am saying that apt asks for Translation-en and the server response
with Translation-en.bz2. APT knows that it can't request the bz2 file if bzip2
isn't available, but some mirrors try to be helpful and clever…
See also http://en.wikipedia.org/wiki/Content_negotiation

Only a few mirrors seem to be configured to act this way, at least de, de2
and us are not effected as far as i have tested.
(which is why i was never hit by that bug after implementing the request for
 uncompressed files to support users with local mirrors which actually have
 these files available)


Best regards

David Kalnischkies




Reply sent to Michael Vogt <mvo@debian.org>:
You have taken responsibility. (Tue, 06 Mar 2012 17:36:27 GMT) Full text and rfc822 format available.

Notification sent to Michael Prokop <mika@debian.org>:
Bug acknowledged by developer. (Tue, 06 Mar 2012 17:36:27 GMT) Full text and rfc822 format available.

Message #44 received at 657560-close@bugs.debian.org (full text, mbox):

From: Michael Vogt <mvo@debian.org>
To: 657560-close@bugs.debian.org
Subject: Bug#657560: fixed in apt 0.8.16~exp13
Date: Tue, 06 Mar 2012 17:32:36 +0000
Source: apt
Source-Version: 0.8.16~exp13

We believe that the bug you reported is fixed in the latest version of
apt, which is due to be installed in the Debian FTP archive:

apt-doc_0.8.16~exp13_all.deb
  to main/a/apt/apt-doc_0.8.16~exp13_all.deb
apt-transport-https_0.8.16~exp13_amd64.deb
  to main/a/apt/apt-transport-https_0.8.16~exp13_amd64.deb
apt-utils_0.8.16~exp13_amd64.deb
  to main/a/apt/apt-utils_0.8.16~exp13_amd64.deb
apt_0.8.16~exp13.dsc
  to main/a/apt/apt_0.8.16~exp13.dsc
apt_0.8.16~exp13.tar.gz
  to main/a/apt/apt_0.8.16~exp13.tar.gz
apt_0.8.16~exp13_amd64.deb
  to main/a/apt/apt_0.8.16~exp13_amd64.deb
libapt-inst1.4_0.8.16~exp13_amd64.deb
  to main/a/apt/libapt-inst1.4_0.8.16~exp13_amd64.deb
libapt-pkg-dev_0.8.16~exp13_amd64.deb
  to main/a/apt/libapt-pkg-dev_0.8.16~exp13_amd64.deb
libapt-pkg-doc_0.8.16~exp13_all.deb
  to main/a/apt/libapt-pkg-doc_0.8.16~exp13_all.deb
libapt-pkg4.12_0.8.16~exp13_amd64.deb
  to main/a/apt/libapt-pkg4.12_0.8.16~exp13_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 657560@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Michael Vogt <mvo@debian.org> (supplier of updated apt package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Tue, 06 Mar 2012 18:12:57 +0100
Source: apt
Binary: apt libapt-pkg4.12 libapt-inst1.4 apt-doc libapt-pkg-dev libapt-pkg-doc apt-utils apt-transport-https
Architecture: source all amd64
Version: 0.8.16~exp13
Distribution: experimental
Urgency: low
Maintainer: APT Development Team <deity@lists.debian.org>
Changed-By: Michael Vogt <mvo@debian.org>
Description: 
 apt        - commandline package manager
 apt-doc    - documentation for APT
 apt-transport-https - https download transport for APT
 apt-utils  - package managment related utility programs
 libapt-inst1.4 - deb package format runtime library
 libapt-pkg-dev - development files for APT's libapt-pkg and libapt-inst
 libapt-pkg-doc - documentation for APT development
 libapt-pkg4.12 - package managment runtime library
Closes: 619646 646288 649314 650513 657560 657695 657732 657902 658096 658346 662762
Changes: 
 apt (0.8.16~exp13) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * apt-pkg/acquire-item.cc:
     - remove 'old' InRelease file if we can't get a new one before
       proceeding with Release.gpg to avoid the false impression of a still
       trusted repository by a (still present) old InRelease file.
       Thanks to Simon Ruderich for reporting this issue! (CVE-2012-0214)
     - add Debug::pkgAcqArchive::NoQueue to disable package downloading
   * apt-pkg/deb/dpkgpm.cc:
     - chroot if needed before dpkg --assert-multi-arch
     - ensure that dpkg binary doesn't have the chroot-directory prefixed
     - call dpkg --assert-multi-arch with execvp instead of execv
     - save the universe by not printing messages about apport if a package
       with this name is not installed (Closes: #619646)
     - handle a SIGINT in all modes as a break after the currently running
       dpkg transaction instead of ignoring it completely
   * apt-pkg/depcache.cc:
     - if a M-A:same package is marked for reinstall, mark all it's installed
       silbings for reinstallation as well (LP: #859188)
   * apt-pkg/contrib/configuration.cc:
     - do not stop parent transversal in FindDir if the value is empty
   * methods/http{s,}.cc:
     - if a file without an extension is requested send an 'Accept: text/*'
       header to avoid that the server chooses unsupported compressed files
       in a content-negotation attempt (Closes: #657560)
     - remove the arbitrary MAXLEN limit for response lines (Closes: #658346)
   * apt-pkg/aptconfiguration.cc:
     - chroot if needed before calling dpkg --print-foreign-architectures
     - ensure that architectures are not added multiple times
   * cmdline/apt-mark.cc:
     - detect if dpkg has multiarch support before calling --set-selections
     - correctly ignore already (un)hold packages
   * apt-pkg/cachefile.cc:
     - clean up lost atomic cachefiles with 'clean' (Closes: #650513)
   * apt-pkg/indexrecords.cc:
     - do not create empty Entries as a sideeffect of Lookup()
   * apt-pkg/acquire-item.cc:
     - drop support for i18n/Index file (introduced in 0.8.11) and use
       the Release file instead to get the Translations (Closes: #649314)
     - use pdiff for Translation-* files if available (Closes: #657902)
   * ftparchive/writer.cc:
     - add 'Translation-*' to the default patterns
   * cmdline/apt-get.cc:
     - if a package can't be removed as it is not installed, suggest to
       the user an (installed) multiarch silbing with 'Did you mean?'
     - improve 'error' message for packages which are only referenced
       e.g. in a Depends line and are now requested for removal
   * cmdline/apt-cache.cc:
     - correct --pre-depends option by using dash consistently (LP: #940837)
   * apt-pkg/packagemanager.cc:
     - do not try to a void a breaks if the broken package pre-depends
       on the breaker, but let dpkg auto-deconfigure it
   * apt-pkg/contrib/fileutl.cc:
     - do not warn about the ignoring of directories (Closes: #662762)
 .
   [ Steve Langasek ]
   * cmdline/apt-get.cc:
     - for cross-build-dependencies M-A: none should be DEB_HOST_ARCH,
       not DEB_BUILD_ARCH (Closes: #646288)
 .
   [ Colin Watson ]
   * apt-pkg/algorithms.cc:
     - don't break out of the main-resolver loop for Breaks to deal with all
       of them in a single iteration (Closes: #657695, LP: #922485)
     - use a signed int instead of short for score calculation as upgrades
       become so big now that it can overflow (Closes: #657732, LP: #917173)
   * Fix IndexCopy::CopyPackages and TranslationsCopy::CopyTranslations to
     handle compressed files again (LP: #924182, closes: #658096)
 .
   [ Michael Vogt ]
   * apt-pkg/deb/dpkgpm.cc:
     - fix crash when a package is in removed but residual config state
       (LP: #923807)
   * apt-pkg/contrib/fileutl.h:
     - fix compat with FileFd::OpenDescriptor() in ReadOnlyGzip mode
   * apt-pkg/packagemanager.cc:
     - fix bug in predepends handling - ensure that packages that needs
       unpackaging are unpacked before they are configured (LP: #927993)
 .
   [ Julian Andres Klode ]
   * apt-pkg/deb/deblistparser.cc:
     - Set the Essential flag on APT instead of only Important
   * apt-pkg/packagemanager.cc:
     - Do not use immediate configuration for packages with the Important flag
   * Treat the Important flag like the Essential flag with those differences:
     - No Immediate configuration (see above)
     - Not automatically installed during dist-upgrade
     - No higher score for installation ordering
Checksums-Sha1: 
 32ba0d502d1e73af5918b5b7dd06a6a62cb73a0a 1690 apt_0.8.16~exp13.dsc
 7601a34f5ca64bf7ff45b6daf8266f2c473dd06b 3402230 apt_0.8.16~exp13.tar.gz
 3b4edc5ff5e77ebf0b124c3055489db8bdca72e5 251982 apt-doc_0.8.16~exp13_all.deb
 70f37715459d2834474358745080d36e51d0bd46 829466 libapt-pkg-doc_0.8.16~exp13_all.deb
 e5799a01fa7c917f3376f25868883f2c6342d50a 1015192 libapt-pkg4.12_0.8.16~exp13_amd64.deb
 bdb04d9f4c7679a7f40b8e615f92e939ed6a7421 186948 libapt-inst1.4_0.8.16~exp13_amd64.deb
 623fd35eb83dba3fffc0b5263aad211c0a5024e4 1164922 apt_0.8.16~exp13_amd64.deb
 4572ec2c4eeaf146dad9ef40b4d0c0794bfedc68 175832 libapt-pkg-dev_0.8.16~exp13_amd64.deb
 dbedaabb89b071234c9891df79a5f4d7f3a1f269 272420 apt-utils_0.8.16~exp13_amd64.deb
 f4b6b505783c4cfdcb5cbda6a590b3d95345f20c 98362 apt-transport-https_0.8.16~exp13_amd64.deb
Checksums-Sha256: 
 752fe0120e4b5be7d8bb065fa903c082ddc09330894d404d3b385097631939f1 1690 apt_0.8.16~exp13.dsc
 5cde730a24638ccbcfac5089644db56388d3650f7c61bf768555fa3db308ce59 3402230 apt_0.8.16~exp13.tar.gz
 adeacff9bbd89cfee1c1faf4a966c36ea006a4c554980b1e1b90cc3e8018bff5 251982 apt-doc_0.8.16~exp13_all.deb
 7a6e1410de78715e82d57a7deb8a86ef80610cad0ded4979d768ca54a52021e1 829466 libapt-pkg-doc_0.8.16~exp13_all.deb
 013d26a664eea5e3624415f0664c38ca955f0cbbc106776d5e3215dd5769c07e 1015192 libapt-pkg4.12_0.8.16~exp13_amd64.deb
 9e8d23220bb22eef341619c2fbfc0c8ccc508eaded82fea9bcc38798f5171bd8 186948 libapt-inst1.4_0.8.16~exp13_amd64.deb
 928bd77863b9edd67f83a5300d0fbf81bba2cf84743a7716d9c0676267730927 1164922 apt_0.8.16~exp13_amd64.deb
 30dad707728310b160f4a31d9ce7219ec3c48e23d5bd389ccc30a7861cee79b7 175832 libapt-pkg-dev_0.8.16~exp13_amd64.deb
 0f14b7537e66d43a7e4dd5fdf41eaf52bebec12a975a9fa53a075603bcfe76c1 272420 apt-utils_0.8.16~exp13_amd64.deb
 690ea82b8a05baed990abe72b14e5781cc1a6ff2da7678d4c0c258b13e5656a2 98362 apt-transport-https_0.8.16~exp13_amd64.deb
Files: 
 36fec50713ebb62b5f8d0457e433029d 1690 admin important apt_0.8.16~exp13.dsc
 64d460c47b1b58e42e1f70be86ddb250 3402230 admin important apt_0.8.16~exp13.tar.gz
 2efa431d666c7e7cf5d66b8ef4d337b4 251982 doc optional apt-doc_0.8.16~exp13_all.deb
 2769797e1e9c27ae54a6784d8e20761b 829466 doc optional libapt-pkg-doc_0.8.16~exp13_all.deb
 4964a90d91f9bdbacf7a77de1d85ebf1 1015192 admin important libapt-pkg4.12_0.8.16~exp13_amd64.deb
 6d0f84a70da94ece33a6529dc005626a 186948 admin important libapt-inst1.4_0.8.16~exp13_amd64.deb
 5062a82fde1e0bd3a0875051f01022e1 1164922 admin important apt_0.8.16~exp13_amd64.deb
 cd77bd303d6f44d8097b318910096d3f 175832 libdevel optional libapt-pkg-dev_0.8.16~exp13_amd64.deb
 e499a62db417c3251e93401bcd24ff5b 272420 admin important apt-utils_0.8.16~exp13_amd64.deb
 9eebcaa60ccb01dd3828e278f4e632d8 98362 admin optional apt-transport-https_0.8.16~exp13_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAk9WRsgACgkQliSD4VZixzR7hgCfXYmM1w1sxB463L18bu/M9L9t
StsAni0R4HU3lhuIozpuwZiVkxm0MSJh
=6Tva
-----END PGP SIGNATURE-----





Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Sat, 31 Mar 2012 07:03:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Craig Sanders <cas@taz.net.au>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Sat, 31 Mar 2012 07:03:03 GMT) Full text and rfc822 format available.

Message #49 received at 657560@bugs.debian.org (full text, mbox):

From: Craig Sanders <cas@taz.net.au>
To: 657560@bugs.debian.org
Subject: Re: Bug#657560: #657560: apt: ...i18n_Translation-en Encountered a section with no Package: header
Date: Sat, 31 Mar 2012 17:51:33 +1100
On Tue, Mar 06, 2012 at 12:15:38PM +0100, David Kalnischkies wrote:
> No, i am saying that apt asks for Translation-en and the
> server response with Translation-en.bz2. APT knows that
> it can't request the bz2 file if bzip2 isn't available,
> but some mirrors try to be helpful and clever… See also
> http://en.wikipedia.org/wiki/Content_negotiation
>
> Only a few mirrors seem to be configured to act this way, at least
> de, de2 and us are not effected as far as i have tested. (which is
> why i was never hit by that bug after implementing the request for
> uncompressed files to support users with local mirrors which actually
> have these files available)

good explanation, thanks.

but even given the content negotiation issue, apt-get somehow recognises
that the Translation-en file is actually bzipped and tries to decompress
it. if bzip2 is installed, it succeeds. if not, it fails.

Also, without bzip2 installed, neither aptitude nor apt-cache or other
tools will have full descriptions available.  So users can't find out
the details on a package before they install it, and 'apt-cache search'
can't search on the non-existant full-text description.

IMO, bumping bzip2 to Recommends isn't any kind of an over-reaction.
without bzip2, the functionality of apt (and others) is impaired.



BTW, the content negotiation configuration must be a lot more common
than you think - i've tried three mirrors, and they all behaved the
same. one was the aarnet.edu.au mirror, and the other two were my
own mirrors at work and at home.  The latter two at least I know are
standard debian apache2 default installs (negotiation module enabled by
default, and without any content-neg customisations)

$ cat /etc/apache2/mods-enabled/negotiation.conf
<IfModule mod_negotiation.c>
#
# LanguagePriority allows you to give precedence to some languages
# in case of a tie during content negotiation.
#
# Just list the languages in decreasing order of preference. We have
# more or less alphabetized them here. You probably want to change this.
#
LanguagePriority en ca cs da de el eo es et fr he hr it ja ko ltz nl nn no pl pt pt-BR ru sv tr zh-CN zh-TW

#
# ForceLanguagePriority allows you to serve a result page rather than
# MULTIPLE CHOICES (Prefer) [in case of a tie] or NOT ACCEPTABLE (Fallback)
# [in case no accepted languages matched the available variants]
#
ForceLanguagePriority Prefer Fallback

</IfModule>


craig

-- 
craig sanders <cas@taz.net.au>

BOFH excuse #242:

Software uses US measurements, but the OS is in metric...




Information forwarded to debian-bugs-dist@lists.debian.org, APT Development Team <deity@lists.debian.org>:
Bug#657560; Package apt. (Tue, 03 Apr 2012 12:51:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to David Kalnischkies <kalnischkies+debian@gmail.com>:
Extra info received and forwarded to list. Copy sent to APT Development Team <deity@lists.debian.org>. (Tue, 03 Apr 2012 12:51:10 GMT) Full text and rfc822 format available.

Message #54 received at 657560@bugs.debian.org (full text, mbox):

From: David Kalnischkies <kalnischkies+debian@gmail.com>
To: Craig Sanders <cas@taz.net.au>, 657560@bugs.debian.org
Subject: Re: Bug#657560: #657560: apt: ...i18n_Translation-en Encountered a section with no Package: header
Date: Tue, 3 Apr 2012 14:46:54 +0200
On Sat, Mar 31, 2012 at 08:51, Craig Sanders <cas@taz.net.au> wrote:
> On Tue, Mar 06, 2012 at 12:15:38PM +0100, David Kalnischkies wrote:
>> No, i am saying that apt asks for Translation-en and the
>> server response with Translation-en.bz2. APT knows that
>> it can't request the bz2 file if bzip2 isn't available,
>> but some mirrors try to be helpful and clever… See also
>> http://en.wikipedia.org/wiki/Content_negotiation
>
> good explanation, thanks.
>
> but even given the content negotiation issue, apt-get somehow recognises
> that the Translation-en file is actually bzipped and tries to decompress
> it. if bzip2 is installed, it succeeds. if not, it fails.

If bzip2 is installed APT will request Translation-en.bz2 before asking for
the uncompressed Translation-en. There is no magic recognizing which type
a file we requested has because magic usually fails and we know it anyway
based on the filename we have requested.

(So, in essence we do client side content negotiation based on the Release
 file and do not expect the server to try content negotiation on his side)


> Also, without bzip2 installed, neither aptitude nor apt-cache or other
> tools will have full descriptions available.  So users can't find out
> the details on a package before they install it, and 'apt-cache search'
> can't search on the non-existant full-text description.

That is right, but that's not a change as this was the case for Translation-*
since ever. It's just now that LongDescriptions are shipped in Translation-en,
but i couldn't search in my local before that either.

> IMO, bumping bzip2 to Recommends isn't any kind of an over-reaction.
> without bzip2, the functionality of apt (and others) is impaired.

We could recommend it, but that doesn't help much as bzip2 is only
"optional", so it wouldn't be included on cd/chroot.

I guess we will need to implement libbz2 support in some way.
dpkg (pre-)depends on that so it wouldn't be a new requirement
for the base system.


Best regards

David Kalnischkies




Reply sent to Michael Vogt <mvo@debian.org>:
You have taken responsibility. (Mon, 16 Apr 2012 17:21:50 GMT) Full text and rfc822 format available.

Notification sent to Michael Prokop <mika@debian.org>:
Bug acknowledged by developer. (Mon, 16 Apr 2012 17:21:50 GMT) Full text and rfc822 format available.

Message #59 received at 657560-close@bugs.debian.org (full text, mbox):

From: Michael Vogt <mvo@debian.org>
To: 657560-close@bugs.debian.org
Subject: Bug#657560: fixed in apt 0.9.0
Date: Mon, 16 Apr 2012 17:17:21 +0000
Source: apt
Source-Version: 0.9.0

We believe that the bug you reported is fixed in the latest version of
apt, which is due to be installed in the Debian FTP archive:

apt-doc_0.9.0_all.deb
  to main/a/apt/apt-doc_0.9.0_all.deb
apt-transport-https_0.9.0_amd64.deb
  to main/a/apt/apt-transport-https_0.9.0_amd64.deb
apt-utils_0.9.0_amd64.deb
  to main/a/apt/apt-utils_0.9.0_amd64.deb
apt_0.9.0.dsc
  to main/a/apt/apt_0.9.0.dsc
apt_0.9.0.tar.gz
  to main/a/apt/apt_0.9.0.tar.gz
apt_0.9.0_amd64.deb
  to main/a/apt/apt_0.9.0_amd64.deb
libapt-inst1.5_0.9.0_amd64.deb
  to main/a/apt/libapt-inst1.5_0.9.0_amd64.deb
libapt-pkg-dev_0.9.0_amd64.deb
  to main/a/apt/libapt-pkg-dev_0.9.0_amd64.deb
libapt-pkg-doc_0.9.0_all.deb
  to main/a/apt/libapt-pkg-doc_0.9.0_all.deb
libapt-pkg4.12_0.9.0_amd64.deb
  to main/a/apt/libapt-pkg4.12_0.9.0_amd64.deb



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 657560@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Michael Vogt <mvo@debian.org> (supplier of updated apt package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA1

Format: 1.8
Date: Mon, 16 Apr 2012 15:53:17 +0200
Source: apt
Binary: apt libapt-pkg4.12 libapt-inst1.5 apt-doc libapt-pkg-dev libapt-pkg-doc apt-utils apt-transport-https
Architecture: source all amd64
Version: 0.9.0
Distribution: unstable
Urgency: low
Maintainer: APT Development Team <deity@lists.debian.org>
Changed-By: Michael Vogt <mvo@debian.org>
Description: 
 apt        - commandline package manager
 apt-doc    - documentation for APT
 apt-transport-https - https download transport for APT
 apt-utils  - package managment related utility programs
 libapt-inst1.5 - deb package format runtime library
 libapt-pkg-dev - development files for APT's libapt-pkg and libapt-inst
 libapt-pkg-doc - documentation for APT development
 libapt-pkg4.12 - package managment runtime library
Closes: 353290 500198 540227 559733 596498 619646 621836 622110 624218 625960 632271 632520 639008 639290 640590 643787 646288 646381 649314 649340 649451 650513 652834 652835 653504 655590 656530 657560 657695 657732 657902 658096 658346 659333 662762 663372 664833 665833
Changes: 
 apt (0.9.0) unstable; urgency=low
 .
   * upload to debian/unstable
 .
 apt (0.9.0~exp1) experimental; urgency=low
 .
   [ Michael Vogt ]
   * apt-pkg/packagemanager.cc:
     - fix inconsistent clog/cout usage in the debug output
     - add APT::pkgPackageManager::MaxLoopCount to ensure that the
       ordering code does not get into a endless loop when it flip-flops
       between two states
   * update libapt-inst1.4 to libapt-inst1.5 because of the cleanup
     performed
   * prepare debian/unstable upload, if there are no issues with this
     upload it will directly go into unstable as 0.9.0
 .
   [ David Kalnischkies ]
   * do not update po and pot files in the process of the build as this
     causes timestamp changes for the mo files which therefore can't
     be refcounted by dpkg for your M-A: same packages
     (Closes: #659333, LP: #924628)
   * apt-inst/database.{cc,h}, apt-inst/deb/dpkgdb.{cc,h}:
     - drop instead of fix as it is only needed if you want to reimplement dpkg
       and comes straight from the beginning of last decade (Closes: #663372)
   * apt-inst/deb/debfile.cc:
     - {Extract,Merge}Control() is another instance of "lets reimplement dpkg"
       so shot of this code before someone ends up using this…
   * debian/libapt-pkg4.12:
     - update symbols file
   * debian/apt-utils.install:
     - ship the ftparchive, apt-extractemplates and apt-sortpkgs locales
       in the apt-utils package instead of the apt package
   * apt-pkg/packagemanager.cc:
     - recheck all dependencies if we changed a package in SmartConfigure
       as this could break an earlier dependency (LP: #940396)
     - recheck dependencies in SmartUnpack after a change, too
   * apt-pkg/acquire-worker.cc:
     - check return of write() as gcc recommends
   * apt-pkg/acquire.cc:
     - check return of write() as gcc recommends
   * apt-pkg/cdrom.cc:
     - check return of chdir() and link() as gcc recommends
   * apt-pkg/clean.cc:
     - check return of chdir() as gcc recommends
   * apt-pkg/contrib/netrc.cc:
     - check return of asprintf() as gcc recommends
   * methods/rred.cc:
     - check return of writev() as gcc recommends
   * methods/mirror.cc:
     - check return of chdir() as gcc recommends
   * apt-pkg/deb/dpkgpm.cc:
     - check return of write() a gcc recommends
   * apt-inst/deb/debfile.cc:
     - check return of chdir() as gcc recommends
   * apt-inst/deb/dpkgdb.cc:
     - check return of chdir() as gcc recommends
   * methods/makefile:
     - do not link rred against libz anymore as FileFd handles all
       this transparently now
   * debian/control:
     - bump Standards-Version to 3.9.3 (no changes needed)
     - add libbz2-dev as new build-dependency
     - remove the libz-dev alternative from zlib1g-dev build-dependency
     - suggest xz-utils instead of bzip2 and lzma
   * doc/apt-get.8.xml:
     - typofix: respect → respecting, thanks Mike Erickson! (Closes: #664833)
   * debian/rules:
     - do not sed in configure.in to set the version-number
   * prepare-release:
     - add as a small script to lazy check and prepare releases
   * doc/*:
     - move the command synopsis out of each manpage into apt-verbatim.ent
       as they are a hell to translate and just single out the parameters
       which can be translated to apt.ent
   * apt-pkg/aptconfiguration.cc:
     - if present, prefer xz binary over lzma
     - if we have zlib builtin insert add a dummy gzip compressor for FileFD
     - do the same for bz2 builtin if available
   * methods/bzip2.cc:
     - remove it as the functionality for all compressors can be
       provided by gzip.cc now with the usage of FileFD
   * apt-pkg/contrib/fileutl.cc:
     - use libz2 library for (de)compression instead of the bzip2 binary as
       the first is a dependency of dpkg and the later just priority:optional
       so we gain 'easier' access to bz2-compressed Translation files this way
   * cmdline/apt-get.cc:
     - print list of autoremoves in alphabetical order (Closes: #639008)
 .
   [ Bogdan Purcareata ]
   * doc/apt-get.8.xml:
     - add 'download' to the usage line (Closes: #649340)
   * cmdline/apt-get.cc:
     - distinguish information about 'apt-get autoremove' based on the
       number of auto-removed packages both before and after the list
       of packages (Closes: #665833)
 .
   [ Steve Langasek ]
   * don't treat build-depends-indep as cross-build-dependencies; we should
     always install the host arch versions.  LP: #968828.
 .
   [ Paolo Rotolo ]
   * Fix string from automatic to automatically (LP: #967393).
 .
 apt (0.8.16~exp13) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * apt-pkg/acquire-item.cc:
     - remove 'old' InRelease file if we can't get a new one before
       proceeding with Release.gpg to avoid the false impression of a still
       trusted repository by a (still present) old InRelease file.
       Thanks to Simon Ruderich for reporting this issue! (CVE-2012-0214)
     - add Debug::pkgAcqArchive::NoQueue to disable package downloading
   * apt-pkg/deb/dpkgpm.cc:
     - chroot if needed before dpkg --assert-multi-arch
     - ensure that dpkg binary doesn't have the chroot-directory prefixed
     - call dpkg --assert-multi-arch with execvp instead of execv
     - save the universe by not printing messages about apport if a package
       with this name is not installed (Closes: #619646)
     - handle a SIGINT in all modes as a break after the currently running
       dpkg transaction instead of ignoring it completely
   * apt-pkg/depcache.cc:
     - if a M-A:same package is marked for reinstall, mark all it's installed
       silbings for reinstallation as well (LP: #859188)
   * apt-pkg/contrib/configuration.cc:
     - do not stop parent transversal in FindDir if the value is empty
   * methods/http{s,}.cc:
     - if a file without an extension is requested send an 'Accept: text/*'
       header to avoid that the server chooses unsupported compressed files
       in a content-negotation attempt (Closes: #657560)
     - remove the arbitrary MAXLEN limit for response lines (Closes: #658346)
   * apt-pkg/aptconfiguration.cc:
     - chroot if needed before calling dpkg --print-foreign-architectures
     - ensure that architectures are not added multiple times
   * cmdline/apt-mark.cc:
     - detect if dpkg has multiarch support before calling --set-selections
     - correctly ignore already (un)hold packages
   * apt-pkg/cachefile.cc:
     - clean up lost atomic cachefiles with 'clean' (Closes: #650513)
   * apt-pkg/indexrecords.cc:
     - do not create empty Entries as a sideeffect of Lookup()
   * apt-pkg/acquire-item.cc:
     - drop support for i18n/Index file (introduced in 0.8.11) and use
       the Release file instead to get the Translations (Closes: #649314)
     - use pdiff for Translation-* files if available (Closes: #657902)
   * ftparchive/writer.cc:
     - add 'Translation-*' to the default patterns
   * cmdline/apt-get.cc:
     - if a package can't be removed as it is not installed, suggest to
       the user an (installed) multiarch silbing with 'Did you mean?'
     - improve 'error' message for packages which are only referenced
       e.g. in a Depends line and are now requested for removal
   * cmdline/apt-cache.cc:
     - correct --pre-depends option by using dash consistently (LP: #940837)
   * apt-pkg/packagemanager.cc:
     - do not try to a void a breaks if the broken package pre-depends
       on the breaker, but let dpkg auto-deconfigure it
   * apt-pkg/contrib/fileutl.cc:
     - do not warn about the ignoring of directories (Closes: #662762)
 .
   [ Steve Langasek ]
   * cmdline/apt-get.cc:
     - for cross-build-dependencies M-A: none should be DEB_HOST_ARCH,
       not DEB_BUILD_ARCH (Closes: #646288)
 .
   [ Colin Watson ]
   * apt-pkg/algorithms.cc:
     - don't break out of the main-resolver loop for Breaks to deal with all
       of them in a single iteration (Closes: #657695, LP: #922485)
     - use a signed int instead of short for score calculation as upgrades
       become so big now that it can overflow (Closes: #657732, LP: #917173)
   * Fix IndexCopy::CopyPackages and TranslationsCopy::CopyTranslations to
     handle compressed files again (LP: #924182, closes: #658096)
 .
   [ Michael Vogt ]
   * apt-pkg/deb/dpkgpm.cc:
     - fix crash when a package is in removed but residual config state
       (LP: #923807)
   * apt-pkg/contrib/fileutl.h:
     - fix compat with FileFd::OpenDescriptor() in ReadOnlyGzip mode
   * apt-pkg/packagemanager.cc:
     - fix bug in predepends handling - ensure that packages that needs
       unpackaging are unpacked before they are configured (LP: #927993)
 .
   [ Julian Andres Klode ]
   * apt-pkg/deb/deblistparser.cc:
     - Set the Essential flag on APT instead of only Important
   * apt-pkg/packagemanager.cc:
     - Do not use immediate configuration for packages with the Important flag
   * Treat the Important flag like the Essential flag with those differences:
     - No Immediate configuration (see above)
     - Not automatically installed during dist-upgrade
     - No higher score for installation ordering
 .
 apt (0.8.16~exp12) experimental; urgency=low
 .
   [ Michael Vogt ]
   * apt-pkg/deb/dpkgpm.cc:
     - fix segfault on pkg removal
 .
   [ David Kalnischkies ]
   * apt-pkg/cacheiterators.h:
     - return the correct version arch for all+foreign, too
   * apt-pkg/packagemanager.cc:
     - ignore breaks on not-installed versions while searching for
       breakage loops as we don't have to avoid them
   * debian/control:
     - remove APT from the short descriptions as lintian doesn't like it
       and it doesn't transport any information for a reader anyway
     - apply typofixes by Pascal De Vuyst, thanks! (Closes: #652834, #652835)
   * debian/rules:
     - apply patch to enable usage of hardning CPPFLAGS and LDFLAGS by
       Moritz Muehlenhoff, thanks! (Closes: #653504)
   * methods/https.cc:
     - use curls list append instead of appending Range and If-Range by hand
       which generates malformed requests, thanks Mel Collins for the hint!
       (Closes: #646381)
   * test/libapt/run-tests:
     - hurd doesn't have dmesg yet and we don't really need it either,
       so use with $0 a more stable data source for hashsumming
 .
   [ Pino Toscano ]
   * test/libapt/globalerror_test.cc:
     - errno 0 has a different strerror on hurd, so generate the expected
       message dynamically instead of hardcoding 'Success' (Closes: #656530)
 .
 apt (0.8.16~exp11) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * apt-pkg/deb/dpkgpm.cc:
     - redirect out/input of dpkg --assert-multi-arch to /dev/null
     - if multi-arch is detected ensure that pkg:all is reported as pkg:all
 .
 apt (0.8.16~exp10) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * apt-pkg/depcache.cc:
     - implicit conflicts (for multiarch) are supposed to conflict
       only with real packages, not with virtual providers
   * apt-pkg/pkgcache.cc:
     - ignore implicit conflicts on providers in AllTarget, too
   * apt-pkg/deb/dpkgpm.cc:
     - check if dpkg supports multiarch with --assert-multi-arch
       and if it does be always explicit about the architecture
   * apt-pkg/contrib/fileutl.h:
     - store the offset in the internal fd before calculate size of
       the zlib-handled file to jump back to this place again
   * apt-pkg/aptconfiguration.cc:
     - parse dpkg --print-foreign-architectures correctly in
       case archs are separated by newline instead of space, too.
       (Closes: #655590)
 .
   [ Michael Vogt ]
   * apt-pkg/contrib/fileutl.h:
     - fix segfault triggered by the python-apt testsuite
 .
 apt (0.8.16~exp9) experimental; urgency=low
 .
   [ Julian Andres Klode ]
   * apt-pkg/cdrom.cc:
     - Accept .bz2, .xz files in addition to .gz files (Closes: #649451)
 .
   [ Michael Vogt ]
   * apt-pkg/cdrom.cc:
     - use aptconfiguration to get the supported compression types
   * debian/control:
     - bump debhelper build-dep to debhelper (>= 8.1.3~)
     - set libapt-pkg-dev to multi-arch: same too
   * g++ 4.7 fixes
 .
   [ Colin Watson ]
   * Convert libapt-pkg4.12 and libapt-inst1.4 to Multi-Arch: same.
 .
   [ David Kalnischkies ]
   * apt-pkg/cacheset.cc:
     - make the cachesets real containers which can embedding any container
       to be able to use the same interface regardless of set or list usage
     - provide a {Package,Version}List similar to {Package,Version}Set
   * cmdline/apt-{get,cache,mark}.cc:
     - use Lists instead of Sets if input order should be preserved for
       commands accepting lists of packages, e.g. policy (Closes: #625960)
   * apt-pkg/depcache.cc:
     - prefer native providers over foreigns even if the chain is foreign
   * cmdline/apt-get.cc:
     - ignore foreign architectures if we check if a provides has only one
       resolver as it's basically the same for the user, so no need to choose
   * cmdline/apt-config.cc:
     - dump the APT::Compressor settings correctly and completely
   * apt-pkg/contrib/fileutl.{h,cc}:
     - implement a ModificationTime method for FileFd
     - add a ReadLine method
     - drop the explicit export of gz-compression handling
   * apt-pkg/cdrom.cc:
     - support InRelease files on cdrom
 .
 apt (0.8.16~exp8) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * algorithms.cc:
     - show a debug why a package was kept by ResolveByKeep()
   * apt-pkg/packagemanager.cc:
     - do not fail on unpacked packages in SmartUnPack, just don't
       shedule them for unpack, but do all checks and configure them
     - do not enter an endless loop for (essential) pre-dependency loops
   * apt-pkg/contrib/sha2_internal.cc:
     - use a pointer-union to peace gcc strict-aliasing warning
   * apt-pkg/deb/deblistparser.cc:
     - M-A: foreign packages provide for other archs, too
 .
 apt (0.8.16~exp7) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * do not pollute namespace in the headers with using (Closes: #500198)
   * use forward declaration in headers if possible instead of includes
   * remove old APT_COMPATIBILITY ifdef's
   * apt-pkg/deb/dpkgpm.cc:
     - use std::vector instead of fixed size arrays to store args and
       multiarch-packagename strings
     - load the dpkg base arguments only one time and reuse them later
   * cmdline/apt-get.cc:
     - follow Provides in the evaluation of saving candidates, too, for
       statisfying garbage package dependencies (Closes: #640590)
   * apt-pkg/algorithms.cc:
     - if a package is garbage, don't try to save it with FixByInstall
   * apt-pkg/deb/debsrcrecords.cc:
     - remove the limit of 400 Binaries for a source package (Closes: #622110)
   * apt-pkg/deb/deblistparser.cc:
     - fix crash when the dynamic mmap needs to be grown in
       LoadReleaseInfo (LP: #854090)
   * apt-pkg/deb/debmetaindex.cc:
     - none is a separator, not a language: no need for Index (Closes: #624218)
   * apt-pkg/aptconfiguration.cc:
     - do not builtin languages only if none is forced (Closes: #643787)
   * apt-pkg/pkgcachegen.cc:
     - refactor MergeList by creating -Group, -Package and -Version specialist
     - share description list between "same" versions (LP: #868977)
       This also means that descriptions are shared across archives now.
     - add implicit dependencies needed for Multi-Arch at the time a Version
       struct is created and not at the end of the cache generation
   * apt-pkg/pkgcache.cc:
     - always prefer "en" over "" for "en"-language regardless of cache-order
 .
   [ Michael Vogt ]
   * apt-pkg/contrib/configuration.cc:
     - fix double delete (LP: #848907)
     - ignore only the invalid regexp instead of all options
   * apt-pkg/acquire-item.h, apt-pkg/deb/debmetaindex.cc:
     - fix fetching language information by adding OptionalSubIndexTarget
   * methods/https.cc:
     - cleanup broken downloads properly
 .
   [ Colin Watson ]
   * ftparchive/cachedb.cc:
     - fix buffersize in bytes2hex
 .
 apt (0.8.16~exp6) experimental; urgency=low
 .
   [ Christopher Baines ]
   * enable APT in unpack/configure ordering to handle loops as well
     as tight dependencies between immediate packages better
     enabling also the possibility to mark all packages as immediate
     (at least Closes: #353290, #540227, #559733, #621836, #639290)
 .
   [ David Kalnischkies ]
   * [abi-break] Support large files in the complete toolset. Indexes of this
     size are pretty unlikely for now, but we need it for deb
     packages which could become bigger than 4GB now (LP: #815895)
   * merged the debian-sid branch
 .
   [ Michael Vogt ]
   * bump ABI version
 .
 apt (0.8.16~exp5) experimental; urgency=low
 .
   * merged the latest debian-sid fixes
   * apt-pkg/makefile:
     - install sha256.h compat header
   * apt-pkg/pkgcachegen.{cc,h}:
     - use ref-to-ptr semantic in NewDepends() to ensure that the
       libapt does not segfault if the cache is remapped in between
       (LP: #812862)
     - fix crash when P.Arch() was used but the cache got remapped
   * apt-pkg/acquire-item.{cc,h}:
     - do not check for a "Package" tag in optional index targets
       like the translations index
   * apt-pkg/acquire.cc:
     - fix potential divide-by-zero
   * methods/mirror.cc:
     - include the architecture(s) in the query string as well so
       that the server can make better decisions
 .
 apt (0.8.16~exp4) experimental; urgency=low
 .
   [ Julian Andres Klode ]
   * apt-pkg/pkgcache.h:
     - [ABI break] Add pkgCache::Header::CacheFileSize, storing the cache size
   * apt-pkg/pkgcachegen.cc:
     - Write the file size to the cache
   * apt-pkg/pkgcache.cc:
     - Check that cache is at least CacheFileSize bytes large (LP: #16467)
 .
   [ Michael Vogt ]
   * merged latest fixes from debian-sid
   * apt-pkg/cdrom.{cc,h}:
     - cleanup old ABI break avoidance hacks
   * [ABI break] apt-pkg/acquire-item.{cc,h}:
     - cleanup around OptionalIndexTarget and SubIndexTarget
   * [ABI break] merged patch from Jonathan Thomas to have a new
     RecordField() function in the pkgRecorder parser. Many thanks
     Thomas
   * [ABI break] merge patch from Jonathan Thomas to speed up the
     depcache by caching the install-recommends and install-suggests
     values
   * apt-pkg/contrib/fileutl.{cc,h}:
     - add GetModificationTime() helper
   * apt-pkg/pkgcachegen.cc:
     - regenerate the cache if the sources.list changes to ensure
       that changes in the ordering there will be honored by apt
   * apt-pkg/sourcelist.{cc,h}:
     - add pkgSourceList::GetLastModifiedTime() helper
 .
 apt (0.8.16~exp3) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * apt-pkg/pkgcache.h:
     - readd All{Foreign,Allowed} as suggested by Julian to
       remain strictly API compatible
   * apt-pkg/acquire*.{cc,h}:
     - try even harder to support really big files in the fetcher by
       converting (hopefully) everything to 'long long' (Closes: #632271)
   * ftparchive/writer.cc:
     - generate all checksums in one run over the file for Release
   * cmdline/apt-get.cc:
     - add an --assume-no option for testing to say 'no' to everything
   * apt-pkg/deb/debmetaindex.cc:
     - add trusted=yes option to mark unsigned (local) repository as trusted
       based on a patch from Ansgar Burchardt, thanks a lot! (Closes: #596498)
 .
   [ Michael Vogt ]
   * merge fixes from the debian/unstable upload
   * merge lp:~mvo/apt/sha512-template to get fixes for the
     sha1/md5 verifiation (closes: #632520)
 .
 apt (0.8.16~exp2) experimental; urgency=low
 .
   [ David Kalnischkies ]
   * [ABI-Break] Implement EDSP in libapt-pkg so that all front-ends which
     use the internal resolver can now be used also with external
     ones as the usage is hidden in between the old API
   * provide two edsp solvers in apt-utils:
     - 'dump' to quickly output a complete scenario and
     - 'apt' to use the internal as an external resolver
   * apt-pkg/pkgcache.h:
     - clean up mess with the "all" handling in MultiArch to
       fix LP: #733741 cleanly for everyone now
   * apt-pkg/depcache.cc:
     - use a boolean instead of an int for Add/Remove in AddStates
       similar to how it works with AddSizes
     - let the Mark methods return if their marking was successful
     - if a Breaks can't be upgraded, remove it. If it or a Conflict
       can't be removed the installation of the breaker fails.
   * cmdline/apt-get.cc:
     - do not discard the error messages from the resolver and instead
       only show the general 'Broken packages' message if nothing else
 .
   [ Stefano Zacchiroli ]
   * doc/external-dependency-solver-protocol.txt:
     - describe EDSP and the configuration interface around it
 .
   [ Michael Vogt ]
   * [ABI-Break] merge lp:~mvo/apt/sha512-template to add support for sha512
   * [ABI-Break] merge lp:~mvo/apt/dpointer to support easier extending
     without breaking the ABI
   * increase ABI version and update package names
 .
 apt (0.8.16~exp1) experimental; urgency=low
 .
   * merged with the debian/unstable upload
Checksums-Sha1: 
 fc95da4daa2a1568bc5acd39ab4af63ec1820780 1663 apt_0.9.0.dsc
 fc3f40502d23333f220e4e6514ca9d001d387b77 3413809 apt_0.9.0.tar.gz
 13f76db32f4ce0311c8d74ab4170e3fa46c6202a 253740 apt-doc_0.9.0_all.deb
 c82ea78974c9c49cbfebf4cf2378610c715d395d 829988 libapt-pkg-doc_0.9.0_all.deb
 47ba3fd9d06f4d923ccdd4bb133c456a5b3de57b 873740 libapt-pkg4.12_0.9.0_amd64.deb
 418b2736f47b3c22ec9caa3bc9d8d5bfcc9a9b09 156814 libapt-inst1.5_0.9.0_amd64.deb
 efb3a085bc077bbadccd11bcb7fa726865820243 1157074 apt_0.9.0_amd64.deb
 c0046bfbdc1be9f50769fd52ef1e2d7b75a9ca40 176948 libapt-pkg-dev_0.9.0_amd64.deb
 50c59ca1d1baba9d6c6cd6a81c4a48839ba21931 369252 apt-utils_0.9.0_amd64.deb
 812d23a09ce7acdee2c463e8d1df1d1212482810 99976 apt-transport-https_0.9.0_amd64.deb
Checksums-Sha256: 
 b5efa4315aa7956a467356cbd5a9647f04a0b726d52dffd651fcce3e94e60835 1663 apt_0.9.0.dsc
 a8cf8af3251a2f8e3d939dce69ce84d4c9320c499c01183471a4918d2fcef0be 3413809 apt_0.9.0.tar.gz
 d5246add11f5ea8007ba0f5c16add3750583ba689ea72726cd7b4237dd1e42c3 253740 apt-doc_0.9.0_all.deb
 8f669ee3f961df54ad7ffbb39ca1ff5eac9b5700bad20165997eb1a7efd0c860 829988 libapt-pkg-doc_0.9.0_all.deb
 49a07e004d87678a56c21efc49109d85666a09a559487f960a9969f3ad1f9abd 873740 libapt-pkg4.12_0.9.0_amd64.deb
 52d53e744546181288e94a5526046e45113b9b0cb45ff9d2d9287dfa7797668b 156814 libapt-inst1.5_0.9.0_amd64.deb
 9db94005d54437feee3eac020e22fd9e85ca53d10528a52150241a3fe1f493f1 1157074 apt_0.9.0_amd64.deb
 e71efeda5b64d29aeb4da6b051e3732319c3ebaa49b6be57a81de57d7e242fab 176948 libapt-pkg-dev_0.9.0_amd64.deb
 d5f6a970d25152a304b7d4cdfa7592399bd7a379b456be543b4aac3fa4d6555b 369252 apt-utils_0.9.0_amd64.deb
 0f44eb74360b8ace4c03a190df566f88033e7d4c8dcb1e177a24e7f320a50f93 99976 apt-transport-https_0.9.0_amd64.deb
Files: 
 a606ce414eb9a7234d43276601383622 1663 admin important apt_0.9.0.dsc
 cf73c2b5f5428d536801a1edc48f0d11 3413809 admin important apt_0.9.0.tar.gz
 2cd144c8fdbe818cfc6e2bb16ddc0b33 253740 doc optional apt-doc_0.9.0_all.deb
 1bc9224c399e7dd0fc7dfcc730b3947e 829988 doc optional libapt-pkg-doc_0.9.0_all.deb
 fe831381997d9423c3daa80ce0d8491c 873740 admin important libapt-pkg4.12_0.9.0_amd64.deb
 63676485e73e922621cb2e0fac3ace6f 156814 admin important libapt-inst1.5_0.9.0_amd64.deb
 76e6ab6d2d06d7a895c4ef2f4da98ad6 1157074 admin important apt_0.9.0_amd64.deb
 e304af794f6f4be0b877882877f3c88a 176948 libdevel optional libapt-pkg-dev_0.9.0_amd64.deb
 0df83118a37c5893155ac2d9fcf8b2a9 369252 admin important apt-utils_0.9.0_amd64.deb
 7e9150fe4ee5be28a476c714bd70422c 99976 admin optional apt-transport-https_0.9.0_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iEYEARECAAYFAk+MUBMACgkQliSD4VZixzRuGQCfQrCgw4t9ts0LCLxZeafSquT2
X10AoJFelZR+3rybe+zx15X0jaxiIcuz
=+UJn
-----END PGP SIGNATURE-----





Merged 657560 657563 659049 Request was from Daniel Hartwig <mandyke@gmail.com> to control@bugs.debian.org. (Wed, 25 Apr 2012 10:50:52 GMT) Full text and rfc822 format available.

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Wed, 30 May 2012 07:37:10 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sun Apr 20 01:35:37 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.